import table
from base import *
import button as icon

class Dialog(table.Table):
    def __init__(self,title,main,**params):
        params.setdefault('cls','dialog')
        table.Table.__init__(self,**params)
        
        self.tr()
        
        t = table.Table(cls=self.cls+".bar")
        t.tr()
        t.td(title)
        clos = icon.Icon(self.cls+".bar.close")
        t.td(clos,align=1)
        clos.connect(CLICK,self.close,None) 
        self.add(t,0,0)
        
        main.rect.w,main.rect.h = main.resize()
        clos.rect.w,clos.rect.h = clos.resize()
        title.container.style.width = main.rect.w - clos.rect.w
        
        self.tr()
        self.td(main,cls=self.cls+".main")
