import object

class Form(object.Object):
    def __init__(self):
        self._elist = []
        self._emap = {}
        self._dirty = 0
        Form.form = self
    
    def add(self,e,name=None,value=None):
        if name != None: e.name = name
        if value != None: e.value = value
        self._elist.append(e)
        self._dirty = 1
    
    def _clean(self):
        for e in self._elist[:]:
            if not hasattr(e,'name') or e.name == None:
                self._elist.remove(e)
        self._emap = {}
        for e in self._elist:
            self._emap[e.name] = e
        self._dirty = 0
    
    #def __setitem__(self,k,v):
    #    if self._dirty: self._clean()
    #    self._emap[k].value = v
    
    def __getitem__(self,k):
        if self._dirty: self._clean()
        return self._emap[k]
    
    def __contains__(self,k):
        if self._dirty: self._clean()
        if k in self._emap: return True
        return False
    
    def results(self):
        if self._dirty: self._clean()
        r = {}
        for e in self._elist:
            r[e.name] = e.value
        return r
    
    def items(self):
        return self.results().items()
    
    def start(self):
        Object.start(self,-1)
